package com.vendor.loader.ui;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.vendor.loader.Messages;
import com.vendor.loader.controler.GlobleControler;
import com.vendor.loader.struct.FileSystem;
import com.vendor.loader.struct.FlashType;
import com.vendor.loader.struct.UpgradeFileInfo;
import com.vendor.loader.ui.AbstractComposite;
import com.vendor.loader.util.StringUtil;
import java.io.File;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ICellModifier;
import org.eclipse.swt.widgets.TableItem;

class null implements ICellModifier {
  public boolean canModify(Object element, String property) {
    return true;
  }
  
  public Object getValue(Object element, String property) {
    if (element instanceof UpgradeFileInfo) {
      UpgradeFileInfo info = (UpgradeFileInfo)element;
      if (property.equals(AbstractComposite.COLUMN_PROPERTIES[AbstractComposite.FLASH_TYPE_COL])) {
        FlashType flashType = info.getFlashType();
        String[] items = AbstractComposite.this.flashTypeEditor.getItems();
        for (int i = 0; i < items.length; i++) {
          if (items[i].equals(flashType.name()))
            return Integer.valueOf(i); 
        } 
        return Integer.valueOf(0);
      } 
      if (property.equals(AbstractComposite.COLUMN_PROPERTIES[AbstractComposite.FILE_SYSTEM_COL])) {
        String[] items = AbstractComposite.this.fileSystemEditor.getItems();
        for (int i = 0; i < items.length; i++) {
          if (items[i].equals(info.getFileSystem().name()))
            return Integer.valueOf(i); 
        } 
        return Integer.valueOf(0);
      } 
      if (property.equals(AbstractComposite.COLUMN_PROPERTIES[AbstractComposite.FLASH_INDEX_COL]))
        return Integer.valueOf(info.getFlashIndex()); 
      if (GlobleControler.intance.is64Bit()) {
        if (property
          .equals(AbstractComposite.COLUMN_PROPERTIES[AbstractComposite.PARTITIONNAMECOL]))
          return (info.getPartitionName() == null) ? "" : 
            info.getPartitionName(); 
        if (property
          .equals(AbstractComposite.COLUMN_PROPERTIES[AbstractComposite.PARTITIONVERSIONCOL]))
          return "0x" + Integer.toHexString(info
              .getPartitionVersion()); 
        if (property
          .equals(AbstractComposite.COLUMN_PROPERTIES[AbstractComposite.PARTITIONVERIFYTAGCOL]))
          return String.valueOf(info.getPartitionVerifyTag()); 
      } 
      if (property.equals(AbstractComposite.COLUMN_PROPERTIES[AbstractComposite.START_ADDRESS_COL]))
        return StringUtil.convertUnit(info.getStartAddress()); 
      if (property.equals(AbstractComposite.COLUMN_PROPERTIES[AbstractComposite.File_Length_COL])) {
        long length = info.getLength();
        if (length == -1L)
          return "-"; 
        return StringUtil.convertUnit(length);
      } 
      if (property.equals(AbstractComposite.COLUMN_PROPERTIES[AbstractComposite.FILE_NAME_COL]))
        return (info.getFileName() == null) ? "" : 
          info.getFileName(); 
    } 
    return null;
  }
  
  public void modify(Object element, String property, Object value) {
    try {
      TableItem item = (TableItem)element;
      UpgradeFileInfo info = (UpgradeFileInfo)item.getData();
      if (property.equals(AbstractComposite.COLUMN_PROPERTIES[AbstractComposite.FLASH_TYPE_COL])) {
        Integer index = AbstractComposite.this.getInteger(value);
        String string = AbstractComposite.this.flashTypeEditor.getItems()[index.intValue()];
        FlashType oldValue = info.getFlashType();
        if (oldValue != FlashType.valueOf(string)) {
          if (oldValue.equals(FlashType.emmc) || oldValue.equals(FlashType.ssd) || 
            FlashType.valueOf(string).equals(FlashType.emmc) || 
            FlashType.valueOf(string).equals(FlashType.ssd))
            info.setFileSystem(FileSystem.none); 
          info.setFlashType(FlashType.valueOf(string));
          AbstractComposite.this.updateAddressAtControlChanged(info, oldValue, info
              .getFlashIndex());
        } 
      } 
      if (property.equals(AbstractComposite.COLUMN_PROPERTIES[AbstractComposite.FILE_SYSTEM_COL])) {
        Integer index = AbstractComposite.this.getInteger(value);
        String string = AbstractComposite.this.fileSystemEditor.getItems()[index.intValue()];
        FileSystem oldValue = info.getFileSystem();
        FileSystem valueOf = FileSystem.valueOf(string);
        if (oldValue != valueOf) {
          info.setFileSystem(valueOf);
          if (info.getFileSystem() != null && info
            .getFileSystem().equals(FileSystem.yaffs)) {
            info.setFlashIndex(info.getFlashIndex() | 0x10000);
          } else {
            info.setFlashIndex(info.getFlashIndex() & 0xFFFF);
          } 
        } 
      } 
      if (property.equals(AbstractComposite.COLUMN_PROPERTIES[AbstractComposite.FLASH_INDEX_COL])) {
        Integer index = AbstractComposite.this.getInteger(value);
        int oldIndex = info.getFlashIndex();
        if (oldIndex != index.intValue()) {
          if (info.getFileSystem().equals(FileSystem.yaffs)) {
            info.setFlashIndex(index.intValue() | 0x10000);
          } else {
            info.setFlashIndex(index.intValue() & 0xFFFF);
          } 
          AbstractComposite.this.updateAddressAtControlChanged(info, info
              .getFlashType(), oldIndex);
        } 
      } 
      if (property.equals(AbstractComposite.COLUMN_PROPERTIES[AbstractComposite.START_ADDRESS_COL])) {
        long convertToNumber;
        String valueStr = (String)value;
        if (valueStr.equals("")) {
          convertToNumber = 0L;
        } else {
          convertToNumber = StringUtil.convertToNumber(valueStr);
          if (convertToNumber % 1024L != 0L) {
            MessageDialog.openWarning(AbstractComposite.this.getShell(), Messages.LoaderComposite_9, Messages.LoaderComposite_InvalidUnit);
            AbstractComposite.this.updateAddress(info);
            return;
          } 
        } 
        long oldAddress = info.getStartAddress();
        if (convertToNumber != info.getStartAddress()) {
          info.setStartAddress(convertToNumber);
          AbstractComposite.this.updateAddress(info);
          if (AbstractComposite.this.checkAddressIsConflict(info, AbstractComposite.this.updateFiles)) {
            info.setStartAddress(oldAddress);
            AbstractComposite.this.updateAddress(info);
          } 
        } 
      } 
      if (GlobleControler.intance.is64Bit()) {
        if (property
          .equals(AbstractComposite.COLUMN_PROPERTIES[AbstractComposite.PARTITIONNAMECOL])) {
          String valueStr = (String)value;
          if (valueStr != null && !valueStr.isEmpty()) {
            if (valueStr.length() >= 30) {
              AbstractComposite.this.showError(Messages.SsuUpgradeInfoGroup_NameInputError);
            } else {
              info.setPartitionName(valueStr.trim());
            } 
          } else {
            info.setPartitionName("");
          } 
        } 
        if (property
          .equals(AbstractComposite.COLUMN_PROPERTIES[AbstractComposite.PARTITIONVERSIONCOL])) {
          String valueStr = (String)value;
          if (!StringUtil.hexInRange(valueStr, "0x0", "0xFFFFFFFF")) {
            AbstractComposite.this.showError(Messages.SsuUpgradeInfoGroup_PartitionVersionInputError);
          } else {
            info.setPartitionVersion(
                StringUtil.toBigInteger(valueStr).intValue());
          } 
        } 
        if (property
          .equals(AbstractComposite.COLUMN_PROPERTIES[AbstractComposite.PARTITIONVERIFYTAGCOL])) {
          String valueStr = (String)value;
          info.setPartitionVerifyTag(
              Integer.parseInt(valueStr));
        } 
      } 
      if (property.equals(AbstractComposite.COLUMN_PROPERTIES[AbstractComposite.File_Length_COL])) {
        String valueStr = (String)value;
        if (valueStr.equals("")) {
          long convertToNumber = 0L;
        } else if (valueStr.equals("-") && AbstractComposite.this.updateFiles
          .size() > 0 && AbstractComposite.this.updateFiles
          .get(AbstractComposite.this.updateFiles.size() - 1) == info) {
          if (info.getLength() != -1L) {
            info.setLength(-1L);
            AbstractComposite.this.viewer.refresh();
            AbstractComposite.this.updateAddress(info);
          } 
        } else {
          long convertToNumber = StringUtil.convertToNumber(valueStr);
          if (convertToNumber % 1024L != 0L) {
            MessageDialog.openWarning(AbstractComposite.this
                .getShell(), Messages.LoaderComposite_9, Messages.Length_should_be_with_unit_KorM_or_1024_times);
          } else if (info.getLength() != convertToNumber) {
            if (info.getFileLength() != 0L && convertToNumber < info
              .getFileLength()) {
              MessageDialog.openWarning(AbstractComposite.this
                  .getShell(), Messages.LoaderComposite_9, Messages.InvalidFileLength);
              return;
            } 
            info.setLength(convertToNumber);
            AbstractComposite.this.updateAddress(info);
          } 
        } 
      } 
      if (property.equals(AbstractComposite.COLUMN_PROPERTIES[AbstractComposite.FILE_NAME_COL])) {
        if (value == null)
          return; 
        if (((String)value).equals(info.getFileName()))
          return; 
        try {
          String str = (String)value;
          if (str.length() > 0) {
            File file = new File(str);
            if (file.length() == 0L) {
              MessageDialog.openWarning(AbstractComposite.this
                  .getShell(), Messages.LoaderComposite_9, Messages.InvalidLengthFileName);
              return;
            } 
          } 
        } catch (Exception e) {
          return;
        } 
        info.setFileName((String)value);
        if (info.getFileName() != null)
          info.setFileLength((new File(info
                .getFileName())).length()); 
      } 
    } catch (NumberFormatException e) {
      AbstractComposite.this.showError(Messages.LoaderComposite_InvalidInput);
    } finally {
      AbstractComposite.this.viewer.refresh();
    } 
  }
}
